//
//  main.cpp
//  HighSchoolProgrammingProblem1
//
//  Created by Stephany Coffman-Wolph on 10/1/15.
//  Copyright (c) 2015 Stephany Coffman-Wolph. All rights reserved.
//
using namespace std;

#include <iostream>
#include <string>

bool debug = false;

int main(int argc, const char * argv[])
{

    //cout << "Hello, World!\n";
    
    string encodingWord;
    string message;
    
    do{
        //Get input from user
        getline(cin, message);
        
        if(message.compare("99") == 0) { return 0; }
        
        string delimiter = ";";
        string token = message.substr(0, message.find(delimiter));
        
        if(message.find(delimiter) != string::npos) {encodingWord = token;}
        
        //Convert to lowercase
        for(int i = 0; i<encodingWord.length(); i++)
        {
            char c = encodingWord[i];
            encodingWord[i] = tolower(c);
        }
        
        
        message = message.substr(message.find(delimiter)+1,message.size());
        message.shrink_to_fit();
        
        int length = (int)encodingWord.size();
        int lengthMessage = (int)message.size();
        int rowNumber = (lengthMessage/length) + 1;
        
        //Create the matrix, put in the encoding word on top
        char encodeMatrix[rowNumber][length];
        for(int i=0; i<length; i++)
        {
            encodeMatrix[0][i] = encodingWord[i];
        }
        
        int currLoc = 0;
        
        for(int i = 1; i<rowNumber; i++)
        {
            for(int j=0; j<length; j++)
            {
                encodeMatrix[i][j] = message[currLoc];
                currLoc++;
            }
            
        }
        
        //Print matrix for debugging
        if(debug)
        {
            for(int i = 0; i<rowNumber; i++)
            {
                for(int j=0; j<length; j++)
                {
                    cout << encodeMatrix[i][j] << " ";
                }
                cout << "\n";
            }
        }
        
        //Sort it, Modified Selection Sort
        int pos_min = -1;
        
        for (int i=0; i < length-1; i++)
        {
            pos_min = i;
            
            for (int j=i+1; j < length; j++)
            {
                if (encodeMatrix[0][j] < encodeMatrix[0][pos_min])
                    pos_min = j;
            }
            
            if (pos_min != i)
            {
                char temp[rowNumber];
                
                for(int z = 0; z<rowNumber; z++)
                {
                    temp[z] = encodeMatrix[z][i];
                }
                
                
                for(int z = 0; z<rowNumber; z++)
                {
                    encodeMatrix[z][i] = encodeMatrix[z][pos_min];
                }
                
                for(int z = 0; z<rowNumber; z++)
                {
                    encodeMatrix[z][pos_min] = temp[z];
                }

            }
        }
        
        
        //Print matrix for debugging
        if(debug)
        {
            for(int i = 0; i<rowNumber; i++)
            {
                for(int j=0; j<length; j++)
                {
                    cout << encodeMatrix[i][j] << " ";
                }
                cout << "\n";
            }
        }
        
        //Format as an output string
        string output = "";
        for(int i = 1; i<rowNumber; i++)
        {
            for(int j=0; j<length; j++)
            {
                output += encodeMatrix[i][j];
            }
        }
        
        cout << output << endl;
    
    }while(message.compare("99") != 0);
        
    return 0;
}

